diff --git a/python/blessings/blessings/__init__.py b/python/blessings/blessings/__init__.py
index 081288ba68..e5e71e3654 100644
--- a/python/blessings/blessings/__init__.py
+++ b/python/blessings/blessings/__init__.py
@@ -25,7 +25,7 @@ if ('3', '0', '0') <= python_version_tuple() < ('3', '2', '2+'):  # Good till 3.
 __all__ = ['Terminal']
 
 
-class Terminal(object):
+class Terminal:
     """An abstraction around terminal capabilities
 
     Unlike curses, this doesn't require clearing the screen before doing
@@ -189,7 +189,7 @@ class Terminal(object):
         for descriptor in self._init_descriptor, sys.__stdout__:
             try:
                 return struct.unpack('hhhh', ioctl(descriptor, TIOCGWINSZ, '\000' * 8))[0:2]
-            except IOError:
+            except OSError:
                 pass
         return None, None  # Should never get here
 
@@ -201,9 +201,9 @@ class Terminal(object):
 
             term = Terminal()
             with term.location(2, 5):
-                print 'Hello, world!'
+                print('Hello, world!')
                 for x in xrange(10):
-                    print 'I can do it %i times!' % x
+                    print('I can do it %i times!' % x)
 
         Specify ``x`` to move to a certain column, ``y`` to move to a certain
         row, or both.
@@ -272,7 +272,7 @@ class Terminal(object):
                 # optimization: combine all formatting into a single escape
                 # sequence.
                 return self._formatting_string(
-                    u''.join(self._resolve_formatter(s) for s in formatters))
+                    ''.join(self._resolve_formatter(s) for s in formatters))
             else:
                 return ParametrizingString(self._resolve_capability(attr))
 
@@ -289,7 +289,7 @@ class Terminal(object):
             # contain chars > 127, and UTF-8 never changes anything within that
             # range..
             return code.decode('utf-8')
-        return u''
+        return ''
 
     def _resolve_color(self, color):
         """Resolve a color like red or on_bright_green into a callable capability."""
@@ -326,14 +326,14 @@ def derivative_colors(colors):
                [('on_bright_' + c) for c in colors])
 
 
-COLORS = set(['black', 'red', 'green', 'yellow', 'blue', 'magenta', 'cyan', 'white'])
+COLORS = {'black', 'red', 'green', 'yellow', 'blue', 'magenta', 'cyan', 'white'}
 COLORS.update(derivative_colors(COLORS))
 COMPOUNDABLES = (COLORS |
-                 set(['bold', 'underline', 'reverse', 'blink', 'dim', 'italic',
-                      'shadow', 'standout', 'subscript', 'superscript']))
+                 {'bold', 'underline', 'reverse', 'blink', 'dim', 'italic',
+                      'shadow', 'standout', 'subscript', 'superscript'})
 
 
-class ParametrizingString(unicode):
+class ParametrizingString(str):
     """A Unicode string which can be called to parametrize it as a terminal capability"""
     def __new__(cls, formatting, normal=None):
         """Instantiate.
@@ -343,7 +343,7 @@ class ParametrizingString(unicode):
             "normal" capability.
 
         """
-        new = unicode.__new__(cls, formatting)
+        new = str.__new__(cls, formatting)
         new._normal = normal
         return new
 
@@ -360,11 +360,11 @@ class ParametrizingString(unicode):
             # running simply `nosetests` (without progressive) on nose-
             # progressive. Perhaps the terminal has gone away between calling
             # tigetstr and calling tparm.
-            return u''
+            return ''
         except TypeError:
             # If the first non-int (i.e. incorrect) arg was a string, suggest
             # something intelligent:
-            if len(args) == 1 and isinstance(args[0], basestring):
+            if len(args) == 1 and isinstance(args[0], str):
                 raise TypeError(
                     'A native or nonexistent capability template received '
                     '%r when it was expecting ints. You probably misspelled a '
@@ -375,10 +375,10 @@ class ParametrizingString(unicode):
                 raise
 
 
-class FormattingString(unicode):
+class FormattingString(str):
     """A Unicode string which can be called upon a piece of text to wrap it in formatting"""
     def __new__(cls, formatting, normal):
-        new = unicode.__new__(cls, formatting)
+        new = str.__new__(cls, formatting)
         new._normal = normal
         return new
 
@@ -393,7 +393,7 @@ class FormattingString(unicode):
         return self + text + self._normal
 
 
-class NullCallableString(unicode):
+class NullCallableString(str):
     """A dummy class to stand in for ``FormattingString`` and ``ParametrizingString``
 
     A callable bytestring that returns an empty Unicode when called with an int
@@ -402,12 +402,12 @@ class NullCallableString(unicode):
 
     """
     def __new__(cls):
-        new = unicode.__new__(cls, u'')
+        new = str.__new__(cls, '')
         return new
 
     def __call__(self, arg):
         if isinstance(arg, int):
-            return u''
+            return ''
         return arg  # TODO: Force even strs in Python 2.x to be unicodes? Nah. How would I know what encoding to use to convert it?
 
 
@@ -429,7 +429,7 @@ def split_into_formatters(compound):
     return merged_segs
 
 
-class Location(object):
+class Location:
     """Context manager for temporarily moving the cursor"""
     def __init__(self, term, x=None, y=None):
         self.x, self.y = x, y
diff --git a/python/blessings/blessings/tests.py b/python/blessings/blessings/tests.py
index a02a3924a8..09b05559f8 100644
--- a/python/blessings/blessings/tests.py
+++ b/python/blessings/blessings/tests.py
@@ -1,4 +1,3 @@
-# -*- coding: utf-8 -*-
 """Automated tests (as opposed to human-verified test patterns)
 
 It was tempting to mock out curses to get predictable output from ``tigetstr``,
@@ -52,8 +51,8 @@ def test_capability():
 def test_capability_without_tty():
     """Assert capability templates are '' when stream is not a tty."""
     t = TestTerminal(stream=StringIO())
-    eq_(t.save, u'')
-    eq_(t.red, u'')
+    eq_(t.save, '')
+    eq_(t.red, '')
 
 
 def test_capability_with_forced_tty():
@@ -84,11 +83,11 @@ def test_location():
     t = TestTerminal(stream=StringIO(), force_styling=True)
 
     with t.location(3, 4):
-        t.stream.write(u'hi')
+        t.stream.write('hi')
 
     eq_(t.stream.getvalue(), unicode_cap('sc') +
                              unicode_parm('cup', 4, 3) +
-                             u'hi' +
+                             'hi' +
                              unicode_cap('rc'))
 
 
@@ -111,7 +110,7 @@ def test_null_fileno():
     out = StringIO()
     out.fileno = None
     t = TestTerminal(stream=out)
-    eq_(t.save, u'')
+    eq_(t.save, '')
 
 
 def test_mnemonic_colors():
@@ -179,26 +178,26 @@ def test_formatting_functions():
     """Test crazy-ass formatting wrappers, both simple and compound."""
     t = TestTerminal()
     # By now, it should be safe to use sugared attributes. Other tests test those.
-    eq_(t.bold(u'hi'), t.bold + u'hi' + t.normal)
-    eq_(t.green('hi'), t.green + u'hi' + t.normal)  # Plain strs for Python 2.x
+    eq_(t.bold('hi'), t.bold + 'hi' + t.normal)
+    eq_(t.green('hi'), t.green + 'hi' + t.normal)  # Plain strs for Python 2.x
     # Test some non-ASCII chars, probably not necessary:
-    eq_(t.bold_green(u'boö'), t.bold + t.green + u'boö' + t.normal)
+    eq_(t.bold_green('boö'), t.bold + t.green + 'boö' + t.normal)
     eq_(t.bold_underline_green_on_red('boo'),
-        t.bold + t.underline + t.green + t.on_red + u'boo' + t.normal)
+        t.bold + t.underline + t.green + t.on_red + 'boo' + t.normal)
     # Don't spell things like this:
     eq_(t.on_bright_red_bold_bright_green_underline('meh'),
-        t.on_bright_red + t.bold + t.bright_green + t.underline + u'meh' + t.normal)
+        t.on_bright_red + t.bold + t.bright_green + t.underline + 'meh' + t.normal)
 
 
 def test_formatting_functions_without_tty():
     """Test crazy-ass formatting wrappers when there's no tty."""
     t = TestTerminal(stream=StringIO())
-    eq_(t.bold(u'hi'), u'hi')
-    eq_(t.green('hi'), u'hi')
+    eq_(t.bold('hi'), 'hi')
+    eq_(t.green('hi'), 'hi')
     # Test non-ASCII chars, no longer really necessary:
-    eq_(t.bold_green(u'boö'), u'boö')
-    eq_(t.bold_underline_green_on_red('loo'), u'loo')
-    eq_(t.on_bright_red_bold_bright_green_underline('meh'), u'meh')
+    eq_(t.bold_green('boö'), 'boö')
+    eq_(t.bold_underline_green_on_red('loo'), 'loo')
+    eq_(t.on_bright_red_bold_bright_green_underline('meh'), 'meh')
 
 
 def test_nice_formatting_errors():
@@ -206,22 +205,22 @@ def test_nice_formatting_errors():
     t = TestTerminal()
     try:
         t.bold_misspelled('hey')
-    except TypeError, e:
+    except TypeError as e:
         assert 'probably misspelled' in e.args[0]
 
     try:
-        t.bold_misspelled(u'hey')  # unicode
-    except TypeError, e:
+        t.bold_misspelled('hey')  # unicode
+    except TypeError as e:
         assert 'probably misspelled' in e.args[0]
 
     try:
         t.bold_misspelled(None)  # an arbitrary non-string
-    except TypeError, e:
+    except TypeError as e:
         assert 'probably misspelled' not in e.args[0]
 
     try:
         t.bold_misspelled('a', 'b')  # >1 string arg
-    except TypeError, e:
+    except TypeError as e:
         assert 'probably misspelled' not in e.args[0]
 
 
diff --git a/python/blessings/setup.py b/python/blessings/setup.py
index 6af55452d8..57f3d4cf8d 100644
--- a/python/blessings/setup.py
+++ b/python/blessings/setup.py
@@ -4,8 +4,7 @@ from setuptools import setup, find_packages
 
 
 extra_setup = {}
-if sys.version_info >= (3,):
-    extra_setup['use_2to3'] = True
+extra_setup['use_2to3'] = True
 
 setup(
     name='blessings',
diff --git a/python/compare-locales/compare_locales/checks.py b/python/compare-locales/compare_locales/checks.py
index 0faffcc698..654d335ebd 100644
--- a/python/compare-locales/compare_locales/checks.py
+++ b/python/compare-locales/compare_locales/checks.py
@@ -44,7 +44,7 @@ class PrintfException(Exception):
 class PropertiesChecker(Checker):
     '''Tests to run on .properties files.
     '''
-    pattern = re.compile('.*\.properties$')
+    pattern = re.compile(r'.*\.properties$')
     printf = re.compile(r'%(?P<good>%|'
                         r'(?:(?P<number>[1-9][0-9]*)\$)?'
                         r'(?P<width>\*|[0-9]+)?'
@@ -95,7 +95,7 @@ class PropertiesChecker(Checker):
     def checkPrintf(self, refSpecs, l10nValue):
         try:
             l10nSpecs = self.getPrintfSpecs(l10nValue)
-        except PrintfException, e:
+        except PrintfException as e:
             yield ('error', e.pos, e.msg, 'printf')
             return
         if refSpecs != l10nSpecs:
@@ -112,20 +112,20 @@ class PropertiesChecker(Checker):
                         # trailing specs missing, that's just a warning
                         warn = ', '.join('trailing argument %d `%s` missing' %
                                          (i+1, refSpecs[i])
-                                         for i in xrange(i1, i2))
+                                         for i in range(i1, i2))
                     else:
-                        for i in xrange(i1, i2):
+                        for i in range(i1, i2):
                             msgs.append('argument %d `%s` missing' %
                                         (i+1, refSpecs[i]))
                     continue
                 if action == 'insert':
                     # obsolete argument in l10n
-                    for i in xrange(j1, j2):
+                    for i in range(j1, j2):
                         msgs.append('argument %d `%s` obsolete' %
                                     (i+1, l10nSpecs[i]))
                     continue
                 if action == 'replace':
-                    for i, j in zip(xrange(i1, i2), xrange(j1, j2)):
+                    for i, j in zip(range(i1, i2), range(j1, j2)):
                         msgs.append('argument %d `%s` should be `%s`' %
                                     (j+1, l10nSpecs[j], refSpecs[i]))
             if msgs:
@@ -183,7 +183,7 @@ class DTDChecker(Checker):
 
     Also checks for some CSS and number heuristics in the values.
     """
-    pattern = re.compile('.*\.dtd$')
+    pattern = re.compile(r'.*\.dtd$')
 
     eref = re.compile('&(%s);' % DTDParser.Name)
     tmpl = '''<!DOCTYPE elem [%s]>
@@ -253,7 +253,7 @@ class DTDChecker(Checker):
             parser.parse(StringIO(self.tmpl %
                                   (refEnt.all.encode('utf-8') + entities,
                                    '&%s;' % refEnt.key.encode('utf-8'))))
-        except sax.SAXParseException, e:
+        except sax.SAXParseException as e:
             yield ('warning',
                    (0, 0),
                    "can't parse en-US value", 'xmlparse')
@@ -275,7 +275,7 @@ class DTDChecker(Checker):
             parser.parse(StringIO(self.tmpl % (
                 l10nEnt.all.encode('utf-8') + _entities,
                 '&%s;' % l10nEnt.key.encode('utf-8'))))
-        except sax.SAXParseException, e:
+        except sax.SAXParseException as e:
             # xml parse error, yield error
             # sometimes, the error is reported on our fake closing
             # element, make that the end of the last line
@@ -293,7 +293,7 @@ class DTDChecker(Checker):
                     col -= len("<!DOCTYPE elem [")  # first line is DOCTYPE
             yield ('error', (lnr, col), ' '.join(e.args), 'xmlparse')
 
-        warntmpl = u'Referencing unknown entity `%s`'
+        warntmpl = 'Referencing unknown entity `%s`'
         if reflist:
             if inContext:
                 elsewhere = reflist - inContext
@@ -342,7 +342,7 @@ class DTDChecker(Checker):
                         if u != ru:
                             msgs.append("units for %s don't match "
                                         "(%s != %s)" % (s, u, ru))
-                for s in refMap.iterkeys():
+                for s in refMap.keys():
                     msgs.insert(0, '%s only in reference' % s)
                 if msgs:
                     yield ('warning', 0, ', '.join(msgs), 'css')
diff --git a/python/compare-locales/compare_locales/commands.py b/python/compare-locales/compare_locales/commands.py
index 61b58ec4b2..f60c979f36 100644
--- a/python/compare-locales/compare_locales/commands.py
+++ b/python/compare-locales/compare_locales/commands.py
@@ -4,6 +4,7 @@
 
 'Commands exposed to commandlines'
 
+from __future__ import print_function
 import logging
 from optparse import OptionParser, make_option
 
@@ -66,7 +67,7 @@ data in a json useful for Exhibit
         logging.getLogger().setLevel(logging.WARNING -
                                      (options.v - options.q)*10)
         observer = self.handle(args, options)
-        print observer.serialize(type=options.data).encode('utf-8', 'replace')
+        print((observer.serialize(type=options.data).encode('utf-8', 'replace')))
 
     def handle(self, args, options):
         """Subclasses need to implement this method for the actual
@@ -109,8 +110,8 @@ Be careful to specify the right merge directory when using this option."""),
         try:
             observer = compareApp(app, merge_stage=options.merge,
                                   clobber=options.clobber)
-        except (OSError, IOError), exc:
-            print "FAIL: " + str(exc)
+        except (OSError, IOError) as exc:
+            print(("FAIL: " + str(exc)))
             self.parser.exit(2)
         return observer
 
diff --git a/python/compare-locales/compare_locales/compare.py b/python/compare-locales/compare_locales/compare.py
index 4f71c46f8f..d0006ef50f 100644
--- a/python/compare-locales/compare_locales/compare.py
+++ b/python/compare-locales/compare_locales/compare.py
@@ -4,6 +4,7 @@
 
 'Mozilla l10n compare locales tool'
 
+from __future__ import print_function
 import codecs
 import os
 import os.path
@@ -42,7 +43,7 @@ class Tree(object):
         old = None
         new = tuple(parts)
         t = self
-        for k, v in self.branches.iteritems():
+        for k, v in self.branches.items():
             for i, part in enumerate(zip(k, parts)):
                 if part[0] != part[1]:
                     i -= 1
@@ -79,7 +80,7 @@ class Tree(object):
         If flag is 'value', key_or_value is a value object, otherwise
         (flag is 'key') it's a key string.
         '''
-        keys = self.branches.keys()
+        keys = list(self.branches.keys())
         keys.sort()
         if self.value is not None:
             yield (depth, 'value', self.value)
@@ -94,7 +95,7 @@ class Tree(object):
         Only the values need to take care that they're JSON-able.
         '''
         json = {}
-        keys = self.branches.keys()
+        keys = list(self.branches.keys())
         keys.sort()
         if self.value is not None:
             json['value'] = self.value
@@ -110,7 +111,7 @@ class Tree(object):
                 return self.indent * t[0] + '/'.join(t[2])
             return self.indent * (t[0] + 1) + str(t[2])
 
-        return map(tostr, self.getContent())
+        return list(map(tostr, self.getContent()))
 
     def __str__(self):
         return '\n'.join(self.getStrRows())
@@ -164,18 +165,18 @@ class DirectoryCompare(SequenceMatcher):
         self.set_seq2([i for i in other])
         for tag, i1, i2, j1, j2 in self.get_opcodes():
             if tag == 'equal':
-                for i, j in zip(xrange(i1, i2), xrange(j1, j2)):
+                for i, j in zip(range(i1, i2), range(j1, j2)):
                     self.watcher.compare(self.a[i], self.b[j])
             elif tag == 'delete':
-                for i in xrange(i1, i2):
+                for i in range(i1, i2):
                     self.watcher.add(self.a[i], other.cloneFile(self.a[i]))
             elif tag == 'insert':
-                for j in xrange(j1, j2):
+                for j in range(j1, j2):
                     self.watcher.remove(self.b[j])
             else:
-                for j in xrange(j1, j2):
+                for j in range(j1, j2):
                     self.watcher.remove(self.b[j])
-                for i in xrange(i1, i2):
+                for i in range(i1, i2):
                     self.watcher.add(self.a[i], other.cloneFile(self.a[i]))
 
 
@@ -203,14 +204,14 @@ class Observer(object):
 
         self.summary = defaultdict(intdict)
         if 'summary' in state:
-            for loc, stats in state['summary'].iteritems():
+            for loc, stats in state['summary'].items():
                 self.summary[loc].update(stats)
         self.details = state['details']
         self.filter = None
 
     def getSummary(self):
         plaindict = {}
-        for k, v in self.summary.iteritems():
+        for k, v in self.summary.items():
             plaindict[k] = dict(v)
         return plaindict
 
@@ -261,7 +262,7 @@ class Observer(object):
 
     def toExhibit(self):
         items = []
-        for locale in sorted(self.summary.iterkeys()):
+        for locale in sorted(self.summary.keys()):
             summary = self.summary[locale]
             if locale is not None:
                 item = {'id': 'xxx/' + locale,
@@ -339,10 +340,10 @@ class Observer(object):
             return '\n'.join(o)
 
         out = []
-        for locale, summary in sorted(self.summary.iteritems()):
+        for locale, summary in sorted(self.summary.items()):
             if locale is not None:
                 out.append(locale + ':')
-            out += [k + ': ' + str(v) for k, v in sorted(summary.iteritems())]
+            out += [k + ': ' + str(v) for k, v in sorted(summary.items())]
             total = sum([summary[k]
                          for k in ['changed', 'unchanged', 'report', 'missing',
                                    'missingInFiles']
@@ -352,7 +353,7 @@ class Observer(object):
                 rate = (('changed' in summary and summary['changed'] * 100) or
                         0) / total
             out.append('%d%% of entries changed' % rate)
-        return '\n'.join(map(tostr, self.details.getContent()) + out)
+        return '\n'.join(list(map(tostr, self.details.getContent())) + out)
 
     def __str__(self):
         return 'observer'
@@ -391,7 +392,7 @@ class ContentComparer:
             os.makedirs(outdir)
         if not p.canMerge:
             shutil.copyfile(ref_file.fullpath, outfile)
-            print "copied reference to " + outfile
+            print(("copied reference to " + outfile))
             return
         if skips:
             # skips come in ordered by key name, we need them in file order
@@ -412,7 +413,7 @@ class ContentComparer:
         else:
             shutil.copyfile(l10n_file.fullpath, outfile)
             f = codecs.open(outfile, 'ab', p.encoding)
-        print "adding to " + outfile
+        print(("adding to " + outfile))
 
         def ensureNewline(s):
             if not s.endswith('\n'):
@@ -448,17 +449,17 @@ class ContentComparer:
             # we didn't parse this before
             try:
                 p.readContents(ref_file.getContents())
-            except Exception, e:
+            except Exception as e:
                 self.notify('error', ref_file, str(e))
                 return
             self.reference[ref_file] = p.parse()
         ref = self.reference[ref_file]
-        ref_list = ref[1].keys()
+        ref_list = list(ref[1].keys())
         ref_list.sort()
         try:
             p.readContents(l10n.getContents())
             l10n_entities, l10n_map = p.parse()
-        except Exception, e:
+        except Exception as e:
             self.notify('error', l10n, str(e))
             return
         lines = []
@@ -468,12 +469,12 @@ class ContentComparer:
                 lines.append(0)
                 for m in self.nl.finditer(p.contents):
                     lines.append(m.end())
-            for i in xrange(len(lines), 0, -1):
+            for i in range(len(lines), 0, -1):
                 if offset >= lines[i - 1]:
                     return (i, offset - lines[i - 1])
             return (1, offset)
 
-        l10n_list = l10n_map.keys()
+        l10n_list = list(l10n_map.keys())
         l10n_list.sort()
         ar = AddRemove()
         ar.set_left(ref_list)
@@ -542,7 +543,7 @@ class ContentComparer:
                         if tp == 'error' and self.merge_stage is not None:
                             skips.append(l10nent)
                         self.notify(tp, l10n,
-                                    u"%s at line %d, column %d for %s" %
+                                    "%s at line %d, column %d for %s" %
                                     (msg, _l, col, refent.key))
                 pass
         if missing:
@@ -573,7 +574,7 @@ class ContentComparer:
         try:
             p.readContents(f.getContents())
             entities, map = p.parse()
-        except Exception, e:
+        except Exception as e:
             self.notify('error', f, str(e))
             return
         self.notify('missingInFiles', missing, len(map))
@@ -615,7 +616,7 @@ def compareApp(app, other_observer=None, merge_stage=None, clobber=False):
                     clobberdir = os.path.join(locale_merge, module)
                     if os.path.exists(clobberdir):
                         shutil.rmtree(clobberdir)
-                        print "clobbered " + clobberdir
+                        print(("clobbered " + clobberdir))
             dir_comp.compareWith(localization)
     return comparer.observer
 
diff --git a/python/compare-locales/compare_locales/parser.py b/python/compare-locales/compare_locales/parser.py
index a97cf201be..cfbc5a925d 100644
--- a/python/compare-locales/compare_locales/parser.py
+++ b/python/compare-locales/compare_locales/parser.py
@@ -122,10 +122,10 @@ class Parser:
         f = codecs.open(file, 'r', self.encoding)
         try:
             self.contents = f.read()
-        except UnicodeDecodeError, e:
+        except UnicodeDecodeError as e:
             (logging.getLogger('locales')
                     .error("Can't read file: " + file + '; ' + str(e)))
-            self.contents = u''
+            self.contents = ''
         f.close()
 
     def readContents(self, contents):
@@ -219,31 +219,31 @@ class DTDParser(Parser):
     # | [#x200C-#x200D] | [#x2070-#x218F] | [#x2C00-#x2FEF] |
     # [#x3001-#xD7FF] | [#xF900-#xFDCF] | [#xFDF0-#xFFFD] |
     # [#x10000-#xEFFFF]
-    CharMinusDash = u'\x09\x0A\x0D\u0020-\u002C\u002E-\uD7FF\uE000-\uFFFD'
+    CharMinusDash = '\x09\x0A\x0D\u0020-\u002C\u002E-\uD7FF\uE000-\uFFFD'
     XmlComment = '<!--(?:-?[%s])*?-->' % CharMinusDash
-    NameStartChar = u':A-Z_a-z\xC0-\xD6\xD8-\xF6\xF8-\u02FF' + \
-        u'\u0370-\u037D\u037F-\u1FFF\u200C-\u200D\u2070-\u218F' + \
-        u'\u2C00-\u2FEF\u3001-\uD7FF\uF900-\uFDCF\uFDF0-\uFFFD'
+    NameStartChar = ':A-Z_a-z\xC0-\xD6\xD8-\xF6\xF8-\u02FF' + \
+        '\u0370-\u037D\u037F-\u1FFF\u200C-\u200D\u2070-\u218F' + \
+        '\u2C00-\u2FEF\u3001-\uD7FF\uF900-\uFDCF\uFDF0-\uFFFD'
     # + \U00010000-\U000EFFFF seems to be unsupported in python
 
     # NameChar ::= NameStartChar | "-" | "." | [0-9] | #xB7 |
     #     [#x0300-#x036F] | [#x203F-#x2040]
-    NameChar = NameStartChar + ur'\-\.0-9' + u'\xB7\u0300-\u036F\u203F-\u2040'
+    NameChar = NameStartChar + urr'\-\.0-9' + '\xB7\u0300-\u036F\u203F-\u2040'
     Name = '[' + NameStartChar + '][' + NameChar + ']*'
-    reKey = re.compile('(?:(?P<pre>\s*)(?P<precomment>(?:' + XmlComment +
-                       '\s*)*)(?P<entity><!ENTITY\s+(?P<key>' + Name +
-                       ')\s+(?P<val>\"[^\"]*\"|\'[^\']*\'?)\s*>)'
-                       '(?P<post>[ \t]*(?:' + XmlComment + '\s*)*\n?)?)',
+    reKey = re.compile(r'(?:(?P<pre>\s*)(?P<precomment>(?:' + XmlComment +
+                       r'\s*)*)(?P<entity><!ENTITY\s+(?P<key>' + Name +
+                       ')\\s+(?P<val>\"[^\"]*\"|\'[^\']*\'?)\\s*>)'
+                       '(?P<post>[ \t]*(?:' + XmlComment + '\\s*)*\n?)?)',
                        re.DOTALL)
     # add BOM to DTDs, details in bug 435002
-    reHeader = re.compile(u'^\ufeff?'
-                          u'(\s*<!--.*(http://mozilla.org/MPL/2.0/|'
-                          u'LICENSE BLOCK)([^-]+-)*[^-]+-->)?', re.S)
-    reFooter = re.compile('\s*(<!--([^-]+-)*[^-]+-->\s*)*$')
-    rePE = re.compile('(?:(\s*)((?:' + XmlComment + '\s*)*)'
-                      '(<!ENTITY\s+%\s+(' + Name +
-                      ')\s+SYSTEM\s+(\"[^\"]*\"|\'[^\']*\')\s*>\s*%' + Name +
-                      ';)([ \t]*(?:' + XmlComment + '\s*)*\n?)?)')
+    reHeader = re.compile('^\ufeff?'
+                          r'(\s*<!--.*(http://mozilla.org/MPL/2.0/|'
+                          'LICENSE BLOCK)([^-]+-)*[^-]+-->)?', re.S)
+    reFooter = re.compile(r'\s*(<!--([^-]+-)*[^-]+-->\s*)*$')
+    rePE = re.compile(r'(?:(\s*)((?:' + XmlComment + r'\s*)*)'
+                      r'(<!ENTITY\s+%\s+(' + Name +
+                      ')\\s+SYSTEM\\s+(\"[^\"]*\"|\'[^\']*\')\\s*>\\s*%' + Name +
+                      ';)([ \t]*(?:' + XmlComment + '\\s*)*\n?)?)')
 
     def getEntity(self, contents, offset):
         '''
@@ -273,15 +273,15 @@ class DTDParser(Parser):
 
 class PropertiesParser(Parser):
     escape = re.compile(r'\\((?P<uni>u[0-9a-fA-F]{1,4})|'
-                        '(?P<nl>\n\s*)|(?P<single>.))', re.M)
+                        '(?P<nl>\n\\s*)|(?P<single>.))', re.M)
     known_escapes = {'n': '\n', 'r': '\r', 't': '\t', '\\': '\\'}
 
     def __init__(self):
-        self.reKey = re.compile('^(\s*)'
-                                '((?:[#!].*?\n\s*)*)'
-                                '([^#!\s\n][^=:\n]*?)\s*[:=][ \t]*', re.M)
-        self.reHeader = re.compile('^\s*([#!].*\s*)+')
-        self.reFooter = re.compile('\s*([#!].*\s*)*$')
+        self.reKey = re.compile(r'^(\s*)'
+                                '((?:[#!].*?\n\\s*)*)'
+                                '([^#!\\s\n][^=:\n]*?)\\s*[:=][ \t]*', re.M)
+        self.reHeader = re.compile(r'^\s*([#!].*\s*)+')
+        self.reFooter = re.compile(r'\s*([#!].*\s*)*$')
         self._escapedEnd = re.compile(r'\\+$')
         self._trailingWS = re.compile(r'[ \t]*$')
         Parser.__init__(self)
@@ -354,11 +354,11 @@ class DefinesParser(Parser):
     canMerge = False
 
     def __init__(self):
-        self.reKey = re.compile('^(\s*)((?:^#(?!define\s).*\s*)*)'
-                                '(#define[ \t]+(\w+)[ \t]+(.*?))([ \t]*$\n?)',
+        self.reKey = re.compile(r'^(\s*)((?:^#(?!define\s).*\s*)*)'
+                                '(#define[ \t]+(\\w+)[ \t]+(.*?))([ \t]*$\n?)',
                                 re.M)
-        self.reHeader = re.compile('^\s*(#(?!define\s).*\s*)*')
-        self.reFooter = re.compile('\s*(#(?!define\s).*\s*)*$', re.M)
+        self.reHeader = re.compile(r'^\s*(#(?!define\s).*\s*)*')
+        self.reFooter = re.compile(r'\s*(#(?!define\s).*\s*)*$', re.M)
         Parser.__init__(self)
 
 
@@ -373,9 +373,9 @@ class IniParser(Parser):
     ...
     '''
     def __init__(self):
-        self.reHeader = re.compile('^((?:\s*|[;#].*)\n)*\[.+?\]\n', re.M)
-        self.reKey = re.compile('(\s*)((?:[;#].*\n\s*)*)((.+?)=(.*))(\n?)')
-        self.reFooter = re.compile('\s*([;#].*\s*)*$')
+        self.reHeader = re.compile('^((?:\\s*|[;#].*)\n)*\\[.+?\\]\n', re.M)
+        self.reKey = re.compile('(\\s*)((?:[;#].*\n\\s*)*)((.+?)=(.*))(\n?)')
+        self.reFooter = re.compile(r'\s*([;#].*\s*)*$')
         Parser.__init__(self)
 
 
